// Fill out your copyright notice in the Description page of Project Settings.


#include "MyActor.h"
#include "Runtime/Engine/Classes/Materials/Material.h"
#include "ConstructorHelpers.h"
#include "PlatformFileManager.h"
#if WITH_EDITOR
#include "AssetRegistryModule.h"
#endif

// Sets default values
AMyActor::AMyActor()
{
CustomMesh = CreateDefaultSubobject<UProceduralMeshComponent>("CustomMesh");
/*
int c;
for (c = 0; c < 16; c++)
	{
	//
	UProceduralMeshComponent *CustomMesh = CreateDefaultSubobject<UProceduralMeshComponent>("CustomMesh");
	CustomMeshes.Add(CustomMesh);
	}
*/
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

	static ConstructorHelpers::FObjectFinder<UMaterial> OpaqueMaterial(TEXT("Material'/Game/StarterContent/Materials/M_Basic_Wall.M_Basic_Wall'"));
	static ConstructorHelpers::FObjectFinder<UMaterial> TransparentMaterial(TEXT("Material'/Game/StarterContent/Materials/M_Glass.M_Glass'"));
	static ConstructorHelpers::FObjectFinder<UMaterial> TexturedMaterial(TEXT("Material'/Game/StarterContent/Materials/vup_textured.vup_textured'"));
	static ConstructorHelpers::FObjectFinder<UMaterial> TexturedTransparentMaterial(TEXT("Material'/Game/StarterContent/Materials/vup_transparenttextured.vup_transparenttextured'"));
	if(OpaqueMaterial.Object != NULL)
		{
		TheOpaqueMaterial = (UMaterial*)OpaqueMaterial.Object;
		}
	if(TransparentMaterial.Object != NULL)
		{
		TheTransparentMaterial = (UMaterial*)TransparentMaterial.Object;
		}
	if(TexturedMaterial.Object != NULL)
		{
		TheTexturedMaterial = (UMaterial*)TexturedMaterial.Object;
		}
	if(TexturedTransparentMaterial.Object != NULL)
		{
		TheTexturedTransparentMaterial = (UMaterial*)TexturedTransparentMaterial.Object;
		}
}

// Called when the game starts or when spawned
void AMyActor::BeginPlay()
{
	Super::BeginPlay();
}

int AMyActor::ApplyTexture(unsigned section,unsigned tx, unsigned ty, void *tdata, int transparenttexture)
{
UTexture2D* Texture2D = UTexture2D::CreateTransient(tx, ty);
// Ensure there's no compression (we're editing pixel-by-pixel)
Texture2D->CompressionSettings = TextureCompressionSettings::TC_VectorDisplacementmap;
// Turn off Gamma correction
Texture2D->SRGB = 0;
// Make sure it never gets garbage collected
Texture2D->AddToRoot();
FTexture2DMipMap& Mip=Texture2D->PlatformData->Mips[0];
void* Data = Mip.BulkData.Lock( LOCK_READ_WRITE );
int l=tx*ty*4;
memcpy(Data,tdata,l);
Mip.BulkData.Unlock( );
// Update the texture with these new settings
Texture2D->UpdateResource();
MD=CustomMesh->CreateDynamicMaterialInstance(section,transparenttexture?TheTexturedTransparentMaterial:TheTexturedMaterial);
if(MD)
	{ 
	MD->SetTextureParameterValue("DynamicTextureParam", Texture2D);
	}
return 0;
}

int AMyActor::CreateMesh(unsigned section,const TArray<FVector> Vertices,const TArray<int32> Triangles, const TArray<FVector>& Normals, const TArray<FVector2D>& UV0,FLinearColor FLC,int usetexture,unsigned tx,unsigned ty,void *tdata,int transparenttexture)
{
CustomMesh->CreateMeshSection(section, Vertices, Triangles, Normals,UV0,TArray<FVector2D>(), TArray<FVector2D>(),TArray<FVector2D>(),TArray<FColor>(),TArray<FProcMeshTangent>(),false);
if (usetexture)
	{
	UTexture2D* Texture2D = UTexture2D::CreateTransient(tx, ty);
	// Ensure there's no compression (we're editing pixel-by-pixel)
	Texture2D->CompressionSettings = TextureCompressionSettings::TC_VectorDisplacementmap;
	// Turn off Gamma correction
	Texture2D->SRGB = 0;
	// Make sure it never gets garbage collected
	Texture2D->AddToRoot();
	FTexture2DMipMap& Mip=Texture2D->PlatformData->Mips[0];
	void* Data = Mip.BulkData.Lock( LOCK_READ_WRITE );
	//FMemory::Memset(Data, 0xaa, 1024*1024*4 );
	int l=tx*ty*4;
	memcpy(Data,tdata,l);
	/*
	unsigned char *pb=(unsigned char *)Data;
	for (c = 0; c < l; c += 4)
		{
		//pb[3]=255;
		pb+=4;
		}
	*/
	Mip.BulkData.Unlock( );
	// Update the texture with these new settings
	Texture2D->UpdateResource();
	MD=CustomMesh->CreateDynamicMaterialInstance(section,transparenttexture?TheTexturedTransparentMaterial:TheTexturedMaterial);
	if(MD)
		{ 
		MD->SetTextureParameterValue("DynamicTextureParam", Texture2D);
		}
	}
else
	{ 
	MD=CustomMesh->CreateDynamicMaterialInstance(section,FLC.A==1?TheOpaqueMaterial:TheTransparentMaterial);
	}
MD->SetVectorParameterValue("Color", FLC);
return 0;
}

// Called every frame
void AMyActor::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}
