// Fill out your copyright notice in the Description page of Project Settings.


#define GSCALE 0.1

#include "vup.h"
#include "Runtime/Engine/Classes/GameFramework/Actor.h"
#include "Runtime/Engine/Public/EngineUtils.h"
#include "Runtime/Engine/Classes/Materials/MaterialInstanceDynamic.h"
#include "myactor.h"
#include "ProceduralMeshComponent.h"
#include "Engine/Canvas.h"

//#include "MeshDescription.h"
//#include "MeshAttributes.h"
//#include "MeshAttributeArray.h"
//#include "MeshDescriptionOperations.h"
//#include "AssetRegistryModule.h"

//#include "C:\Program Files\Epic Games\UE_4.22\Engine\Plugins\Runtime\ProceduralMeshComponent\Source\ProceduralMeshComponentEditor\Private\ProceduralMeshComponentDetails.h"

int *vup_hwnd;

int (*vupdll_init)(int *);
void (*vupdll_uninit)(void);
int (*vupdll_com) (unsigned char *,unsigned,unsigned char *);
void (*vupdll_settitle) (wchar_t *);

int (*openpipeclient)(char *name);
int (*closepipeclient)(void);
int (*writepipeclient)(unsigned len, unsigned char *data);
int (*leninpipeclient)(void);
int (*readpipeclient)(unsigned minlen, unsigned maxlen, unsigned char *data);


int *(*FindWindowW)(wchar_t *classname,wchar_t *windowname);
int *(*SendMessage)(int *hwnd,int msg,int *wParam,int *lparam);
unsigned (*GlobalGetAtomNameW)(short nAtom,wchar_t *str,int size);
short (*GlobalDeleteAtom)(short nAtom);

AActor **G;
AActor **PG;
short *_isvisible;
short *_selectable;
short *_pickable;

void *dlluser32;
void *dllkernel32;
void *dllvup;
void *dllpipe;
int phase=0;
int _readpipeclient(unsigned minlen,unsigned maxlen,unsigned char *buff)
{
double d=FPlatformTime::Seconds();
int ret;
while ((ret=readpipeclient(minlen, maxlen, buff)) != minlen)
	{
	if (FPlatformTime::Seconds() - d > 0.5)
		{
		return -1000; // timeout
		}
	}
return ret;
}

void Avup::displaytext(FText SomeText,float X,float Y)
{
}


int vup_vcom_connect(int **nsp, wchar_t *prpdir)
{
dlluser32 = FPlatformProcess::GetDllHandle(L"User32.dll");
if (!dlluser32)
	{
	return -1000;
	}
dllkernel32 = FPlatformProcess::GetDllHandle(L"kernel32.dll");
if (!dllkernel32)
	{
	return -1001;
	}
dllvup = FPlatformProcess::GetDllHandle(L"vupdll.dll");
if (!dllvup)
	{
	return -1002;
	}
void *func;
func= FPlatformProcess::GetDllExport(dlluser32, L"FindWindowW");
if (!func)
	{
	return -1003;
	}
FindWindowW = (int *(*)(wchar_t *, wchar_t *))func;
func = FPlatformProcess::GetDllExport(dlluser32, L"SendMessageW");
if (!func)
	{
	return -1004;
	}
SendMessage = (int *(*)(int *,int,int*,int*))func;
func = FPlatformProcess::GetDllExport(dllkernel32, L"GlobalGetAtomNameW");
if (!func)
	{
	return -1005;
	}
GlobalGetAtomNameW=(unsigned(*)(short,wchar_t*,int))func;
func = FPlatformProcess::GetDllExport(dllkernel32, L"GlobalDeleteAtom");
if (!func)
	{
	return -1006;
	}
GlobalDeleteAtom = (short(*)(short))func;
func = FPlatformProcess::GetDllExport(dllvup, L"vupdll_init");
if (!func)
	{
	return -1007;
	}
vupdll_init = (int(*)(int *))func;
func = FPlatformProcess::GetDllExport(dllvup, L"vupdll_settitle");
vupdll_settitle = (void(*)(wchar_t *))func;
func = FPlatformProcess::GetDllExport(dllvup, L"vupdll_uninit");
if (!func)
	{
	return -1107;
	}
vupdll_uninit = (void(*)(void))func;
func = FPlatformProcess::GetDllExport(dllvup, L"vupdll_com");
if (!func)
	{
	return -1008;
	}

vupdll_com = (int(*)(unsigned char *, unsigned,unsigned char *))func;

dllpipe = FPlatformProcess::GetDllHandle(L"pipecomdll.dll");
if (!dllpipe)
	{
	return -1009;
	}

func = FPlatformProcess::GetDllExport(dllpipe, L"openpipeclient");
if (!func)
	{
	return -1010;
	}
openpipeclient=(int(*)(char *))func;

func = FPlatformProcess::GetDllExport(dllpipe, L"closepipeclient");
if (!func)
	{
	return -1011;
	}
closepipeclient = (int(*)(void))func;

func = FPlatformProcess::GetDllExport(dllpipe, L"writepipeclient");
if (!func)
	{
	return -1012;
	}
writepipeclient = (int(*)(unsigned, unsigned char *))func;

func = FPlatformProcess::GetDllExport(dllpipe, L"leninpipeclient");
if (!func)
	{
	return -1013;
	}
leninpipeclient = (int(*)(void))func;

func = FPlatformProcess::GetDllExport(dllpipe, L"readpipeclient");
if (!func)
	{
	return -1014;
	}
readpipeclient = (int(*)(unsigned, unsigned,unsigned char *))func;

UE_LOG(LogTemp, Display, TEXT("Vup connecting step1...."));

vup_hwnd = FindWindowW(L"vu_communication", NULL);
if (!vup_hwnd)
	{
	return -1;
	}
UE_LOG(LogTemp, Display, TEXT("Vup connecting step2...."));
int Z = vupdll_init(vup_hwnd);
if (Z != 1234)
	{
	return -2;
	}
UE_LOG(LogTemp, Display, TEXT("Vup connecting step3...."));
int *LPARAM;
LPARAM = (int *)1235; // signature pour connexion depuis Unreal
if (SendMessage(vup_hwnd, 0x400+0x1241, NULL, LPARAM) != (int *)0x4112)
	{
	return -3;
	}
UE_LOG(LogTemp, Display, TEXT("Vup connecting step4...."));
*nsp = SendMessage(vup_hwnd, 0x400 + 0x1243, NULL, NULL);
UE_LOG(LogTemp, Display, TEXT("Vup connecting step5...."));
int *atom = SendMessage(vup_hwnd, 0x400 + 0x1244, NULL,NULL);
UE_LOG(LogTemp, Display, TEXT("Vup connecting step6...."));
if (atom == 0)
	{
	return -4;
	}
short satom=*((short *)&atom);
GlobalGetAtomNameW(satom, prpdir, 1023);
GlobalDeleteAtom(satom);
if (openpipeclient("vupservice") < 0)
	{
	return -5;
	}
unsigned cmd=0x200;
if (writepipeclient(4, (unsigned char *)&cmd) < 0)
	{
	return -6;
	}
unsigned nsp2=0;
if (_readpipeclient(4, 4,(unsigned char *)&nsp2) < 0)
	{
	return -7;
	}
UE_LOG(LogTemp, Display, TEXT("Vup connecting step7...."));
return 0;
}

int *_nsp;
int nsp;

#pragma pack(1)

	struct _extrai3dinfo2
		{
		char transparenttexture;
		int usetexture;
		unsigned tx,ty;
		};

	struct _extrai3dinfos
	{
		unsigned version;
		unsigned len;
		double scalex, scaley, scalez;
		double rax, ray, raz;
		unsigned gid1, gid2;
		int childof;
		wchar_t name[1024];
		char notselectable;
		char occlusion;
		char transparent;
		char drawbothfaces;
		unsigned nmat;
		char lookatuser;
		double x, y, z;
		double qx, qy, qz, qw;
		char invisible;
	};
#pragma pack()

AActor* CloneActor( FName newname,AActor* aActor, FTransform aSpawnTransform/*, ESpawnActorCollisionHandlingMethod aCollisionHandlingOverride */) {
     if( aActor == NULL ) {
         return NULL;
     }
 
     auto world = aActor->GetWorld( );
 
     if( !world ) {
         return NULL;
     }
 
     FActorSpawnParameters spawnParameters;
     spawnParameters.Name = newname;//aActor->GetFName( );
     spawnParameters.Template = aActor;
     spawnParameters.Owner = aActor->GetOwner( );
     spawnParameters.Instigator = aActor->GetInstigator( );
     //spawnParameters.SpawnCollisionHandlingOverride = aCollisionHandlingOverride;
 
     AActor *newcreated=world->SpawnActorAbsolute<AActor>( aActor->GetClass( ), aSpawnTransform, spawnParameters );
	 return newcreated;
 }

 int editmode=0;

 unsigned nticks;

Avup::Avup()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
}

struct _extrai3dinfos *pextra;
int *pchildof;

struct _extrai3dinfos* getobjectsfromvup(int _Nsp);
struct _extrai3dinfo2* getmatsfromvup(int s,int _Nmat);
#if WITH_EDITOR
void Avup::PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent)
{
	if (PropertyChangedEvent.GetPropertyName().Compare("Import_From_Vup") == 0)
	{
	wchar_t prpdir[1024]=L"";
	UE_LOG(LogTemp, Display, TEXT("Vup connecting...."));
	int ret=vup_vcom_connect(&_nsp, prpdir);
	if(ret<0)
		{ 
		UE_LOG(LogTemp, Warning, TEXT("Vup connect return error %d"), ret);
		}	
	else
		{
		UE_LOG(LogTemp, Display, TEXT("Vup connected"));
		nsp=*((int *)&_nsp);
		if((int)nsp>0)
			{ 
			G=(AActor **)malloc(sizeof(void *)*nsp);
			PG=(AActor **)malloc(sizeof(void *)*nsp);
			_isvisible=(short *)malloc(2*nsp);
			_selectable=(short *)malloc(2*nsp);
			_pickable = (short *)malloc(2*nsp);
			if(G&&PG&&_selectable&&_isvisible&&_pickable)
				{ 
				memset(G,0, sizeof(void *)*nsp);
				memset(PG, 0, sizeof(void *)*nsp);
				memset(_isvisible, -1, 2*nsp);
				phase = 1;
				}
			if (phase==1)
				{
				pextra=getobjectsfromvup(nsp);
				if(pextra)
					{
					phase = 2;
					}
				}
			if (phase == 2)
				{
				int ret=createobjects(GetWorld(),NULL,nsp,pextra,false);
				if(ret>=0)
					{ 
					// Convertir en static mesh
					//if(tostaticmesh(GetWorld(),NULL,nsp,pextra)>=0)
						{
						phase=3;
						}
					}
				else
					{
					UE_LOG(LogTemp, Warning, TEXT("Create objects return error %d"), ret);
					}
				}

			}
		for (int obj = 0; obj < obj; obj++)
			{
			if(pextra[obj].version==2)
				{ 
			/*  terminer : documenter les coordonnes initiales*/
			/*
			if(PG[obj])
				{ 
				PG[obj]->GetRootComponent()->SetRelativeRotation(FQuat(-qz,qx,qy,qw));
				PG[obj]->GetRootComponent()->SetRelativeLocation(FVector(pextra[obj].z / GSCALE, pextra[obj].x / GSCALE, pextra[obj].y / GSCALE));
				}
			if(G[obj])
				{
				G[obj]->GetRootComponent()->SetRelativeLocation(FVector(pextra[obj].raz/GSCALE,pextra[obj].rax/GSCALE,pextra[obj].ray/GSCALE));
				}
			*/
				}
			}
		nticks=0;
		double t=FPlatformTime::Seconds();
		while(nticks<100)
			{
			Tick(-1);
			if(FPlatformTime::Seconds()-t>10)
				{
				break;
				}
			}
		uninit();
		}

	Import_From_Vup=false;
	}
}
#endif


void Avup::uninit(void)
{
if(vupdll_uninit) vupdll_uninit();
if (pextra)
	{
	free(pextra);
	pextra=NULL;
	}
if (pchildof)
	{
	free(pchildof);
	pchildof=NULL;
	}
if (G)
	{
	free(G);
	G=NULL;
	}
if (PG)
	{
	free(PG);
	PG=NULL;
	}
if (_isvisible)
	{
	free(_isvisible);
	_isvisible=NULL;
	}
if (_pickable)
	{
	free(_pickable);
	_pickable=NULL;
	}
if (_selectable)
	{
	free(_selectable);
	_selectable=NULL;
	}

}


void Avup::EndPlay(const EEndPlayReason::Type EndPlayReason)
{
uninit();
}

struct _extrai3dinfo2* getmatsfromvup(int s, int _Nmat)
{
if(_Nmat==0) return 0;
struct _extrai3dinfo2 *_pextra2=(struct _extrai3dinfo2 *)malloc(sizeof(struct _extrai3dinfo2)*_Nmat);
if (!_pextra2)
	{
	return NULL;
	}
memset(_pextra2,0,sizeof(struct _extrai3dinfo2)*_Nmat);
unsigned cmd[2];
cmd[0]=0x202;
cmd[1]=(unsigned)s;
if (writepipeclient(8, (unsigned char *)&cmd) < 0)
	{
	return NULL;
	}
unsigned ret=0;
if (_readpipeclient(4,4,(unsigned char *)&ret) < 0)
	{
	return NULL;
	}
if (ret != _Nmat)
	{
	return NULL;
	}
if (_readpipeclient(sizeof(struct _extrai3dinfo2)*_Nmat, sizeof(struct _extrai3dinfo2)*_Nmat,(unsigned char *)_pextra2) < 0)
	{
	return NULL;
	}
return _pextra2;
}


struct _extrai3dinfos* getobjectsfromvup(int _Nsp)
{
if(_Nsp==0) return 0;
struct _extrai3dinfos *_pextra=(struct _extrai3dinfos *)malloc(sizeof(struct _extrai3dinfos)*_Nsp);
pchildof=(int *)malloc(_Nsp*sizeof(int));
if (!_pextra||!pchildof)
	{
	return NULL;
	}
memset(_pextra,0,sizeof(struct _extrai3dinfos)*_Nsp);
unsigned cmd=0x201;
if (writepipeclient(4, (unsigned char *)&cmd) < 0)
	{
	return NULL;
	}
if (_readpipeclient(sizeof(struct _extrai3dinfos)*_Nsp, sizeof(struct _extrai3dinfos)*_Nsp,(unsigned char *)_pextra) < 0)
	{
	return NULL;
	}
int c;
for(c=0;c<_Nsp;c++)
	{ 
	pchildof[c]=_pextra[c].childof;
	}
return _pextra;
}


// Called when the game starts or when spawned
void Avup::BeginPlay()
{
	Super::BeginPlay();
	wchar_t prpdir[1024]=L"";
	UE_LOG(LogTemp, Display, TEXT("Vup connecting...."));
	int ret=vup_vcom_connect(&_nsp, prpdir);
	if(ret<0)
		{ 
		UE_LOG(LogTemp, Warning, TEXT("Vup connect return error %d"), ret);
		}	
	else
		{
		UE_LOG(LogTemp, Display, TEXT("Vup connected"));
		nsp=*((int *)&_nsp);
		if((int)nsp>0)
			{ 
			G=(AActor **)malloc(sizeof(void *)*nsp);
			PG=(AActor **)malloc(sizeof(void *)*nsp);
			_isvisible=(short *)malloc(2*nsp);
			_selectable=(short *)malloc(2*nsp);
			_pickable = (short *)malloc(2*nsp);
			if(G&&PG)
				{ 
				memset(G,0, sizeof(void *)*nsp);
				memset(PG, 0, sizeof(void *)*nsp);
				memset(_isvisible, -1, 2*nsp);
				phase = 1;
				}
			if (phase==1)
				{
				pextra=getobjectsfromvup(nsp);
				if(pextra)
					{
					phase = 2;
					}
				}
			if (phase == 2)
				{
				if(createobjects(GetWorld(),NULL,nsp,pextra,true)>=0)
					{ 
					// Convertir en static mesh
					//if(tostaticmesh(GetWorld(),NULL,nsp,pextra)>=0)
						{
						phase=3;
						}
					}
				}

			}
		}

}

unsigned char sbuffer[0x1000];
unsigned char buffer[0x800000];

int clicked=-1,picked=-1,mouseover=-1;

float alphas[128];
unsigned cols[128];

int GG,GG2;

void Avup::Tick(float DeltaTime)
{
//wchar_t b[1024];
//swprintf(b,L"B:%u",GG2++);
//UE_LOG(LogTemp, Warning,b);

      //GEngine->AddOnScreenDebugMessage(-1, 15.0f, FColor::Red, "debug msg");
	if(DeltaTime>0) Super::Tick(DeltaTime);
	if (phase == 3)
		{
		int spos=0;
		memset(sbuffer,0,0x1000);
		*((int *)&sbuffer[spos])=clicked;
		spos+=4;
		*((int *)&sbuffer[spos]) = picked;
		spos += 4;
		*((int *)&sbuffer[spos]) = mouseover;
		spos += 4;
		// 16 float position xr1
		spos+=16*4;
		// 6 float velocity xr1
		spos += 6 * 4;
		// buttons xr1
		spos+=8;
		// trigger xr1
		spos += 4;
		// valid xr1
		spos += 2;
		// 16 float position xr2
		spos += 16 * 4;
		// 6 float velocity xr2
		spos += 6 * 4;
		// buttons xr2
		spos += 8;
		// trigger xr2
		spos += 4;
		// valid xr2
		spos += 2;

		// 16 float position xrh
		spos += 16 * 4;
		// 6 float velocity xrh
		spos += 6 * 4;
		// valid xrh
		spos += 2;

		// 3 float picked force
		spos += 3 * 4;

		// 6 float ray
		spos += 6 * 4;

		int len = vupdll_com(sbuffer,spos,buffer);
		if (len > 0)
			{
			nticks++;
//wchar_t b[1024];
//swprintf(b,L"A:%u",GG++);
//UE_LOG(LogTemp, Warning,b);
			int pos = 0;
			int slen = *((int *)&buffer[pos + 4]);
			unsigned nchangedsprite3d = *((unsigned *)&buffer[pos+12]);
			unsigned c;
			pos += slen - 4;
			for (c = 0; c < nchangedsprite3d; c++)
				{
				int slen2 = *((int *)&buffer[pos]);
				int pos2 = pos + 4;
				unsigned num = *((unsigned *)&buffer[pos2]); 
				pos2 += 4;
				unsigned obj = num & 0x7fffffff;
				bool tchanged = false, rchanged = false, schanged = false;
				float x = 0, y = 0, z = 0;
				float rx = 0, ry = 0, rz = 0;
				float qx = 0, qy = 0, qz = 0, qw = 0;
				float arx = 0, ary = 0, arz = 0;
				float sx = 1, sy = 1, sz = 1;
				short visible = 0;
				short selectable = 0;
				short pickable = 0;
				short usetextmat = 0;
				float texoffsetx = 0;
				float texoffsety = 0;
				int childof = -1;
				if ((num & 0x80000000) != 0) // Version optimise : seulement les lments modifis
					{
					unsigned short changed1 = *((unsigned short*)&buffer[pos2]);
					if ((changed1 & 1) != 0)
						{
						tchanged = true;
						x = -*((float*)&buffer[pos2]);
						pos2 += 4;
						}
					if ((changed1 & 2) != 0)
						{
						tchanged = true;
						y = *((float*)&buffer[pos2]);
						pos2 += 4;
						}
					if ((changed1 & 4) != 0)
						{
						tchanged = true;
						z = *((float*)&buffer[pos2]);
						pos2 += 4;
						}
					if ((changed1 & 8) != 0)
						{
						rchanged = true;
						rx = *((float*)&buffer[pos2]);
						pos2 += 4;
						}
					if ((changed1 & 0x10) != 0)
						{
						rchanged = true;
						ry = *((float*)&buffer[pos2]);
						pos2 += 4;
						}
					if ((changed1 & 0x20) != 0)
						{
						rchanged = true;
						rz = -*((float*)&buffer[pos2]);
						pos2 += 4;
						}
					if ((changed1 & 0x40) != 0)
						{
						int posmchange = pos2;
						pos2 += 128 / 4;
						int CM;
						for (CM = 0; CM < 128; CM++)
							{
							if ((buffer[posmchange + CM / 8] & (1 << (CM & 7))) != 0)
								{
								pos2 += 4;
								}
							}
						}
					if ((changed1 & 0x80) != 0)
						{
						int posmchange = pos2;
						pos2 += 128 / 4;
						int CM;
						for (CM = 0; CM < 128; CM++)
							{
							if ((buffer[posmchange + CM / 8] & (1 << (CM & 7))) != 0)
								{
								pos2 += 4;
								}
							}
						}
					if ((changed1 & 0x100) != 0)
						{
						int posmchange = pos2;
						pos2 += 128 / 4;
						int CM;
						for (CM = 0; CM < 128; CM++)
							{
							if ((buffer[posmchange + CM / 8] & (1 << (CM & 7))) != 0)
								{
								pos2 += 4;
								}
							}
						}
					if ((changed1 & 0x200) != 0)
						{
						int posmchange = pos2;
						pos2 += 128 / 4;
						int CM;
						for (CM = 0; CM < 128; CM++)
							{
							if ((buffer[posmchange + CM / 8] & (1 << (CM & 7))) != 0)
								{
								pos2 += 4;
								}
							}
						}
					if ((changed1 & 0x400) != 0)
						{
						visible = *((short*)&buffer[pos2]); //toint16(buffer, pos2);
						pos2 += 2;
						}
					if ((changed1 & 0x800) != 0)
						{
						selectable = *((short*)&buffer[pos2]);
						pos2 += 2;
						}
					if ((changed1 & 0x1000) != 0)
						{
						pickable = *((short*)&buffer[pos2]);
						pos2 += 2;
						}
					if ((changed1 & 0x2000) != 0)
						{
						unsigned short um = *((unsigned short*)&buffer[pos2]);
						pos2 += 2;
						if (um != 0)
							{
							pos2 += 8;
							}
						else
							{
							texoffsetx = *((float*)&buffer[pos2]);
							pos2 += 4;
							texoffsety = *((float*)&buffer[pos2]);
							pos2 += 4;
							}
						}
					if ((changed1 & 0x4000) != 0)
						{
						schanged = true;
						sx = *((float*)&buffer[pos2]);
						pos2 += 4;
						sy = *((float*)&buffer[pos2]);
						pos2 += 4;
						sz = *((float*)&buffer[pos2]);
						pos2 += 4;
						}
					}
				else
					{
					tchanged = true;
					rchanged = true;
					x = -*((float*)&buffer[pos2]);
					pos2 += 4;
					y = *((float*)&buffer[pos2]);
					pos2 += 4;
					z = *((float*)&buffer[pos2]);
					pos2 += 4;
					rx = *((float*)&buffer[pos2]);
					pos2 += 4;
					ry = *((float*)&buffer[pos2]);
					pos2 += 4;
					rz =- *((float*)&buffer[pos2]);
					pos2 += 4;
					qx = *((float*)&buffer[pos2]);
					pos2 += 4;
					qy = *((float*)&buffer[pos2]);
					pos2 += 4;
					qz -= *((float*)&buffer[pos2]);
					pos2 += 4;
					qw -= *((float*)&buffer[pos2]);
					pos2 += 4;
					arx = -*((float*)&buffer[pos2]);
					pos2 += 4;
					ary = *((float*)&buffer[pos2]);
					pos2 += 4;
					arz = *((float*)&buffer[pos2]);
					pos2 += 4;
					if (slen2 >= 2140) // Structure incluant l'chelle
						{
						schanged = true;
						sx = *((float*)&buffer[pos2]);
						pos2 += 4;
						sy = *((float*)&buffer[pos2]);
						pos2 += 4;
						sz = *((float*)&buffer[pos2]);
						pos2 += 4;
					}
					childof = *((int*)&buffer[pos2]);
					pos2 += 4;
					visible = *((short int*)&buffer[pos2]);
					pos2 += 2;
					selectable = *((short int*)&buffer[pos2]);
					pos2 += 2;
					pickable = *((short int*)&buffer[pos2]);
					pos2 += 2;
					// metalness
					pos2 += 128 * 4;
					// roughness
					pos2 += 128 * 4;
					// alpha
					int _rank;
					for (_rank = 0; _rank < 128; _rank++)
						{
						alphas[_rank] = *((float*)&buffer[pos2]);
						pos2 += 4;
						}
					// col
					for (_rank = 0; _rank < 128; _rank++)
						{
						cols[_rank] = *((unsigned*)&buffer[pos2]);
						pos2 += 4;
						}
					usetextmat = *((short int*)&buffer[pos2]);
					pos2 += 2;
					texoffsetx = *((float*)&buffer[pos2]);
					pos2 += 4;
					texoffsety = *((float*)&buffer[pos2]);
					pos2 += 4;
					pos += slen2;
					}
				if (obj < (unsigned)nsp&&G[obj])
					{
					if(pchildof[obj]!=childof)
						{
						if(childof==-1)
							{
							PG[obj]->AttachToActor(this,FAttachmentTransformRules(EAttachmentRule::KeepRelative, true));
							}
						else
							{ 
							PG[obj]->AttachToActor(G[childof],FAttachmentTransformRules(EAttachmentRule::KeepRelative, true));
							}
						pchildof[obj]=childof;
						}


					if (childof != pextra[obj].childof)
						{
						// l'objet n'a pas le mme parent qu' l'origine
						qx=-qx;
						qy=-qy;
						qz=-qz;
						qw=-qw;
						tchanged=true;
						rchanged=true;
						}
					if((visible&1)!=0)
						{ 
						if(_isvisible[obj]!=1)
							{ 
							_isvisible[obj]=1;
							G[obj]->SetActorHiddenInGame(false);
							}
						}
					else
						{ 
						if(_isvisible[obj]!=0)
							{ 
							_isvisible[obj]=0;
							G[obj]->SetActorHiddenInGame(true);
							}
						}
					_selectable[obj] = selectable;
					_pickable[obj] = pickable;
					if (tchanged || rchanged)
						{
						//Quaternion Q = new Quaternion(qx, qy, -qz, qw);
						//PG[obj].transform.localRotation = Q;
						//PG[obj].transform.localPosition = new Vector3(x / GSCALE, y / GSCALE, z / GSCALE);
						//G[obj].transform.localPosition = new Vector3(arx / GSCALE, ary / GSCALE, arz / GSCALE);
						USceneComponent *USC=PG[obj]->GetRootComponent();
						if(USC)
							{ 
							PG[obj]->GetRootComponent()->SetRelativeRotation(FQuat(-qz,qx,qy,qw));
							PG[obj]->GetRootComponent()->SetRelativeLocation(FVector(z / GSCALE, x / GSCALE, y / GSCALE));
							//PG[obj]->SetActorLocation(FVector(x / GSCALE, y / GSCALE, z / GSCALE));
							FVector V=PG[obj]->GetActorLocation();
							G[obj]->GetRootComponent()->SetRelativeLocation(FVector(arz/GSCALE,arx/GSCALE,ary/GSCALE));
							}
						}
					}
				}
			}
		}

}

int Avup::tostatic(UProceduralMeshComponent* ProcMeshComp,int objnum)
{
/*
wchar_t wbuff[1024];
swprintf(wbuff,1023,L"/Game/meshes/%u",objnum);
FString UserPackageName=wbuff;
FName MeshName(*FPackageName::GetLongPackageAssetName(UserPackageName));
FMeshDescription MeshDescription;
UStaticMesh::RegisterMeshAttributes(MeshDescription);
FStaticMeshDescriptionAttributeGetter AttributeGetter(&MeshDescription);
TPolygonGroupAttributesRef<FName> PolygonGroupNames = AttributeGetter.GetPolygonGroupImportedMaterialSlotNames();
TVertexAttributesRef<FVector> VertexPositions = AttributeGetter.GetPositions();
TVertexInstanceAttributesRef<FVector> Tangents = AttributeGetter.GetTangents();
TVertexInstanceAttributesRef<float> BinormalSigns = AttributeGetter.GetBinormalSigns();
TVertexInstanceAttributesRef<FVector> Normals = AttributeGetter.GetNormals();
TVertexInstanceAttributesRef<FVector4> Colors = AttributeGetter.GetColors();
TVertexInstanceAttributesRef<FVector2D> UVs = AttributeGetter.GetUVs();
TEdgeAttributesRef<bool> EdgeHardnesses = AttributeGetter.GetEdgeHardnesses();
TEdgeAttributesRef<float> EdgeCreaseSharpnesses = AttributeGetter.GetEdgeCreaseSharpnesses();
// Materials to apply to new mesh
const int32 NumSections = ProcMeshComp->GetNumSections();
int32 VertexCount = 0;
int32 VertexInstanceCount = 0;
int32 PolygonCount = 0;
TMap<UMaterialInterface*, FPolygonGroupID> UniqueMaterials;
UniqueMaterials.Reserve(NumSections);
TArray<FPolygonGroupID> MaterialRemap;
MaterialRemap.Reserve(NumSections);
//Get all the info we need to create the MeshDescription
for (int32 SectionIdx = 0; SectionIdx < NumSections; SectionIdx++)
	{
	FProcMeshSection* ProcSection = ProcMeshComp->GetProcMeshSection(SectionIdx);
	VertexCount += ProcSection->ProcVertexBuffer.Num();
	VertexInstanceCount += ProcSection->ProcIndexBuffer.Num();
	PolygonCount += ProcSection->ProcIndexBuffer.Num() / 3;
	UMaterialInterface*Material = ProcMeshComp->GetMaterial(SectionIdx);
	if (!UniqueMaterials.Contains(Material))
		{
		FPolygonGroupID NewPolygonGroup = MeshDescription.CreatePolygonGroup();
		UniqueMaterials.Add(Material, NewPolygonGroup);
		PolygonGroupNames[NewPolygonGroup] = Material->GetFName();
		}
	FPolygonGroupID* PolygonGroupID = UniqueMaterials.Find(Material);
	if(PolygonGroupID == nullptr)
		{
		return -1;
		}
	MaterialRemap.Add(*PolygonGroupID);
	}
MeshDescription.ReserveNewVertices(VertexCount);
MeshDescription.ReserveNewVertexInstances(VertexInstanceCount);
MeshDescription.ReserveNewPolygons(PolygonCount);
MeshDescription.ReserveNewEdges(PolygonCount * 2);
UVs.SetNumIndices(4);
//Add Vertex and VertexInstance and polygon for each section
for (int32 SectionIdx = 0; SectionIdx < NumSections; SectionIdx++)
	{
	FProcMeshSection* ProcSection = ProcMeshComp->GetProcMeshSection(SectionIdx);
	FPolygonGroupID PolygonGroupID = MaterialRemap[SectionIdx];
	//Create the vertex
	int32 NumVertex = ProcSection->ProcVertexBuffer.Num();
	TMap<int32, FVertexID> VertexIndexToVertexID;
	VertexIndexToVertexID.Reserve(NumVertex); 
	for (int32 VertexIndex = 0; VertexIndex < NumVertex; ++VertexIndex)
		{
		FProcMeshVertex& Vert = ProcSection->ProcVertexBuffer[VertexIndex];
		const FVertexID VertexID = MeshDescription.CreateVertex();
		VertexPositions[VertexID] = Vert.Position;
		VertexIndexToVertexID.Add(VertexIndex, VertexID);
		}
	//Create the VertexInstance
	int32 NumIndices = ProcSection->ProcIndexBuffer.Num();
	int32 NumTri = NumIndices / 3;
	TMap<int32, FVertexInstanceID> IndiceIndexToVertexInstanceID;
	IndiceIndexToVertexInstanceID.Reserve(NumVertex);
	for (int32 IndiceIndex = 0; IndiceIndex < NumIndices; IndiceIndex++)
		{
		const int32 VertexIndex = ProcSection->ProcIndexBuffer[IndiceIndex];
		const FVertexID VertexID = VertexIndexToVertexID[VertexIndex];
		const FVertexInstanceID VertexInstanceID = MeshDescription.CreateVertexInstance(VertexID);
		IndiceIndexToVertexInstanceID.Add(IndiceIndex, VertexInstanceID);
		FProcMeshVertex& ProcVertex = ProcSection->ProcVertexBuffer[VertexIndex];
		Tangents[VertexInstanceID] = ProcVertex.Tangent.TangentX;
		Normals[VertexInstanceID] = ProcVertex.Normal;
		BinormalSigns[VertexInstanceID] = ProcVertex.Tangent.bFlipTangentY ? -1.f : 1.f;
		Colors[VertexInstanceID] = FLinearColor(ProcVertex.Color);
		UVs.Set(VertexInstanceID, 0, ProcVertex.UV0);
		UVs.Set(VertexInstanceID, 1, ProcVertex.UV1);
		UVs.Set(VertexInstanceID, 2, ProcVertex.UV2);
		UVs.Set(VertexInstanceID, 3, ProcVertex.UV3);
		}
	//Create the polygons for this section
	for (int32 TriIdx = 0; TriIdx < NumTri; TriIdx++)
		{
		FVertexID VertexIndexes[3];
		TArray<FVertexInstanceID> VertexInstanceIDs;
		VertexInstanceIDs.SetNum(3);
		for (int32 CornerIndex = 0; CornerIndex < 3; ++CornerIndex)
			{
			const int32 IndiceIndex = (TriIdx * 3) + CornerIndex;
			const int32 VertexIndex = ProcSection->ProcIndexBuffer[IndiceIndex];
			VertexIndexes[CornerIndex] = VertexIndexToVertexID[VertexIndex];
			VertexInstanceIDs[CornerIndex] = IndiceIndexToVertexInstanceID[IndiceIndex];
			}
		// Insert a polygon into the mesh
		const FPolygonID NewPolygonID = MeshDescription.CreatePolygon(PolygonGroupID, VertexInstanceIDs);
		//Triangulate the polygon
		FMeshPolygon& Polygon = MeshDescription.GetPolygon(NewPolygonID);
		MeshDescription.ComputePolygonTriangulation(NewPolygonID, Polygon.Triangles);
		}
	}
// If we got some valid data.
if (MeshDescription.Polygons().Num() > 0)
	{
	// Then find/create it.
	UPackage* Package = CreatePackage(NULL, *UserPackageName);
	if (Package == NULL)
		{
		return -2;
		}
	// Create StaticMesh object
	UStaticMesh* StaticMesh = NewObject<UStaticMesh>(Package, MeshName, RF_Public | RF_Standalone);
	StaticMesh->InitResources();
	StaticMesh->LightingGuid = FGuid::NewGuid();
	// Add source to new StaticMesh
	FStaticMeshSourceModel& SrcModel = StaticMesh->AddSourceModel();
	SrcModel.BuildSettings.bRecomputeNormals = false;
	SrcModel.BuildSettings.bRecomputeTangents = false;
	SrcModel.BuildSettings.bRemoveDegenerates = false;
	SrcModel.BuildSettings.bUseHighPrecisionTangentBasis = false;
	SrcModel.BuildSettings.bUseFullPrecisionUVs = false;
	SrcModel.BuildSettings.bGenerateLightmapUVs = true;
	SrcModel.BuildSettings.SrcLightmapIndex = 0;
	SrcModel.BuildSettings.DstLightmapIndex = 1;
	FMeshDescription* OriginalMeshDescription = StaticMesh->GetMeshDescription(0);
	if (OriginalMeshDescription == nullptr)
		{
		OriginalMeshDescription = StaticMesh->CreateMeshDescription(0);
		}
	*OriginalMeshDescription = MeshDescription;
	StaticMesh->CommitMeshDescription(0);
	// Copy materials to new mesh
	for (auto Kvp : UniqueMaterials)
		{
		UMaterialInterface* Material = Kvp.Key;
		StaticMesh->StaticMaterials.Add(FStaticMaterial(Material, Material->GetFName(), Material->GetFName()));
		}
	//Set the Imported version before calling the build
	StaticMesh->ImportVersion = EImportStaticMeshVersion::LastVersion;
	// Build mesh from source
	StaticMesh->Build(false);
	StaticMesh->PostEditChange();
	// Notify asset registry of new asset
	FAssetRegistryModule::AssetCreated(StaticMesh);
	}
*/
return 0;
}

int Avup::tostaticmesh(UWorld *world, FSceneInterface *scene, int _Nsp, struct _extrai3dinfos* _pextra)
{
int csp;
for (csp = 0; csp < _Nsp; csp++)
	{
	if(G[csp])
		{
		tostatic(((AMyActor *)G[csp])->CustomMesh,csp);
		}
	}
return 0;
}

int Avup::createobjects(UWorld *world, FSceneInterface *scene, int _Nsp, struct _extrai3dinfos* _pextra,bool connectexisting)
{
AActor *pmodel=NULL;
AActor *ppmodel=NULL;
for (TActorIterator<AActor> Itr(GetWorld()); Itr; ++Itr)
	{
	FString name;
	Itr->GetName(name);
	if (name.Len()>=9&&name.Left(9).Compare(FString::FString(L"vupmodela"))==0)
		{
		ppmodel=*Itr;
		}
	if (name.Len()>=9&&name.Left(9).Compare(FString::FString(L"vupmodelb"))==0)
		{
		pmodel=*Itr;
		}
	}
if (!pmodel||!ppmodel)
	{
	return -1;
	}
int csp;
textnum=0;
for (csp = 0; csp < _Nsp; csp++)
	{
	if(connectexisting)
		{ 
		// Chercher si ces objets existent dj
		AMyActor *pMyActorA=NULL;
		AMyActor *pMyActorB=NULL;
		for (TActorIterator<AMyActor> Itr(GetWorld()); Itr; ++Itr)
			{
			AMyActor *pMyActor=*Itr;
			if (Itr->IsA<AMyActor>())
				{
				if ( pMyActor->gid1 == _pextra[csp].gid1&&pMyActor->gid2 == _pextra[csp].gid2)
					{
					if(pMyActor->isa) pMyActorA=pMyActor;
					else pMyActorB=pMyActor;
					}
				}
			}
		if (pMyActorA&&pMyActorB)
			{
			// Ok, les objets existent dj -> crer les rfrences
			PG[csp]=pMyActorA;
			G[csp]=pMyActorB;
			if (_pextra[csp].invisible)
				{
				pMyActorB->SetActorHiddenInGame(true);
				}
			unsigned mc;
			_extrai3dinfo2 *pextra2=getmatsfromvup(csp,_pextra[csp].nmat);
			if(pextra2)
				{ 
				for(mc=0;mc<_pextra[csp].nmat;mc++)
					{
					// Recharger les textures
					if(pextra2[mc].usetexture)
						{ 
						FILE *f=NULL;
						wchar_t wbuff[1024];
						swprintf(wbuff,1023,L"/Game/vuptext/%u_%u.rawtexture",csp,mc);
						FString UserPackageName=wbuff;
						FName TName(*FPackageName::GetLongPackageAssetName(UserPackageName));
						FString FS=TName.GetPlainNameString();
						const wchar_t *name=(const wchar_t *)*FS;
						wchar_t cur[1024]=L"";
						_wgetcwd(cur,1023);
						_wfopen_s(&f,name,L"rb");
						if (f)
							{
							unsigned tlen=pextra2[mc].tx*pextra2[mc].ty*4;
							unsigned char *pdata=(unsigned char *)malloc(tlen);
							if(pdata)
								{ 
								if (fread(pdata, tlen, 1, f) == 1)
									{
									pMyActorB->ApplyTexture(mc,pextra2[mc].tx,pextra2[mc].ty,(void *)pdata,pextra2[mc].transparenttexture);
									}
								free(pdata);
								}
							fclose(f);
							}
						}
					}
				free(pextra2);
				}
			wchar_t mess[1024];
			swprintf(mess,TEXT("Vup object %u/%u connected"), csp+1,_Nsp);
			UE_LOG(LogTemp, Display, mess);
			if(vupdll_settitle) vupdll_settitle(mess);
			continue;
			}
		}
	FActorSpawnParameters spawnParameters;
	spawnParameters.Owner = pmodel->GetOwner( );
	spawnParameters.Instigator = pmodel->GetInstigator( );

	FTransform FT(FVector(0.0,0.0,0.0));
	wchar_t buff[1024];
	swprintf(buff,1023,L"%u.a",csp);
	spawnParameters.Name=buff;
	AActor *newpactor=CloneActor(buff,ppmodel,FT);
	if (!newpactor)
		{
		return -11;
		}
	((AMyActor*)newpactor)->isa=true;
	((AMyActor*)newpactor)->gid1=_pextra[csp].gid1;
	((AMyActor*)newpactor)->gid2=_pextra[csp].gid2;
	swprintf(buff,1023,L"%u.b",csp);

	AActor *newactor=CloneActor(buff,pmodel,FT);
	if (!newactor)
		{
		return -12;
		}
	((AMyActor*)newactor)->isa=false;
	((AMyActor*)newactor)->gid1=_pextra[csp].gid1;
	((AMyActor*)newactor)->gid2=_pextra[csp].gid2;

	newactor->AttachToActor(newpactor,FAttachmentTransformRules(EAttachmentRule::KeepRelative, true));
	G[csp]=newactor;
	PG[csp]=newpactor;
	if (_pextra[csp].childof != -1)
		{
		PG[csp]->AttachToActor(G[_pextra[csp].childof],FAttachmentTransformRules(EAttachmentRule::KeepRelative, true));
		}
	else
		{
		PG[csp]->AttachToActor(this,FAttachmentTransformRules(EAttachmentRule::KeepRelative, true));
		}
	unsigned section=0;
	_extrai3dinfo2 *pextra2=getmatsfromvup(csp,_pextra[csp].nmat);
	{ 
	do
		{
		TArray<FVector> Vertices;
		TArray<FVector> Normals;
		//TArray<FRuntimeMeshTangent> Tangents;
		TArray<FColor> VertexColors;
		TArray<FVector2D> TextureCoordinates;
		TArray<int32> Triangles;
		// Get geometries infos from vup
		// 1-vertexs
		unsigned getvertexs[4];
		getvertexs[0]=1; // cmd get vertexs
		getvertexs[1]=csp; // sprite number
		getvertexs[2]=section;
		getvertexs[3]=0xffffffff; // get all vertices for this section
		if(writepipeclient(4*4,(unsigned char *)getvertexs)<0)
			{
			return -3;
			}
		int nvertexes=0;
		if (_readpipeclient(4, 4,(unsigned char *)&nvertexes) < 0)
			{
			return -4;
			}
		if(nvertexes<0) break;
		if(nvertexes>0)
			{
			unsigned RLEN=4*3+4*3+4+4*2;
			unsigned LEN=RLEN*nvertexes;
			unsigned char *_buff=(unsigned char *)malloc(LEN);
			if(!_buff)
				{
				return -5;
				}
			// rcupre dans l'ordre : pos, normal, color, tcoord
			if (_readpipeclient(LEN,LEN,_buff) < 0)
				{
				return -6;
				}
			int cvertexes;
			for(cvertexes=0;cvertexes<nvertexes;cvertexes++)
				{
				float *PF;
				PF=(float *)&_buff[cvertexes*RLEN];
				Vertices.Add(FVector(PF[2]/GSCALE,PF[0]/GSCALE,PF[1]/GSCALE));
				Normals.Add(FVector(PF[5],PF[3],PF[4]));
				TextureCoordinates.Add(FVector2D(PF[7],PF[8]));
				}
			free(_buff);

			unsigned gettris[4];
			gettris[0]=4; // cmd get tris (index restart from 0 for each section)
			gettris[1]=csp; // sprite number
			gettris[2]=section;
			gettris[3]=0xffffffff; // get all tris for this section
			if(writepipeclient(4*4,(unsigned char *)gettris)<0)
				{
				return -7;
				}
			int ntris=0;
			if (_readpipeclient(4, 4,(unsigned char *)&ntris) < 0)
				{
				return -8;
				}
			if(ntris<0) break;
			if(ntris>0)
				{
				unsigned TRLEN=4;
				unsigned TLEN=TRLEN*ntris;
				unsigned char *tbuff=(unsigned char *)malloc(TLEN);
				if(!tbuff)
					{
					return -9;
					}
				if (_readpipeclient(TLEN,TLEN,tbuff) < 0)
					{
					return -10;
					}
				int ctris;
				for(ctris=0;ctris<ntris;ctris++)
					{
					int32 *PT;
					PT=(int32 *)&tbuff[ctris*TRLEN];
					Triangles.Add((*PT)-1);
					}
				free(tbuff);
				
				UMaterial* UnrealMaterial = NewObject<UMaterial>();
				unsigned getmat[3];
				getmat[0]=3; // cmd get mat
				getmat[1]=csp; // sprite number
				getmat[2]=section;
				if(writepipeclient(3*4,(unsigned char *)getmat)<0)
					{
					return -11;
					}
				unsigned ret;
				if (_readpipeclient(4, 4, (unsigned char *)&ret) < 0)
					{
					return -12;
					}
				if (ret != 0)
					{
					return -13;
					}
				unsigned _cols[5];
				if (_readpipeclient(5*4, 5*4,(unsigned char *)_cols) < 0)
					{
					return -14;
					}
				float r,g,b;
				b=(unsigned char)_cols[0];
				b/=255;
				g=(unsigned char)(_cols[0]>>8);
				g/=255;
				r=(unsigned char)(_cols[0]>>16);
				r/=255;
				FLinearColor FLC=FLinearColor(r,g,b);
				float f=_cols[4];
				f/=255;
				FLC.A=1-f;
				void *pdata=NULL;
				unsigned tlen=pextra2?(pextra2[section].tx*pextra2[section].ty*4):0;
				if(pextra2&&pextra2[section].usetexture)
					{ 
					pdata=malloc(tlen);
					if (!pdata)
						{
						return -15;
						}
					unsigned gettxt[3];
					gettxt[0]=5; // cmd get texture bitmap
					gettxt[1]=csp; // sprite number
					gettxt[2]=section;
					if(writepipeclient(3*4,(unsigned char *)gettxt)<0)
						{
						free(pdata);
						return -16;
						}
					int iret=-1234;
					if (_readpipeclient(4, 4, (unsigned char *)&iret) < 0)
						{
						free(pdata);
						return -17;
						}
					if (iret != 0)
						{
						free(pdata);
						return -18;
						}
					if (_readpipeclient(tlen, tlen, (unsigned char *)pdata) < 0)
						{
						free(pdata);
						return -19;
						}
					}
				((AMyActor *)newactor)->CreateMesh(section,Vertices,Triangles,Normals,TextureCoordinates,FLC,pextra2?pextra2[section].usetexture:0,pextra2?pextra2[section].tx:0,pextra2?pextra2[section].ty:0,pdata,pextra2?pextra2[section].transparenttexture:0);
				if (pdata)
					{
					FILE *fr=NULL;
					wchar_t wbuff[1024];
					swprintf(wbuff,1023,L"/Game/vuptext/%u_%u.rawtexture",csp,section);
					FString UserPackageName=wbuff;
					FName TName(*FPackageName::GetLongPackageAssetName(UserPackageName));
					FString FS=TName.GetPlainNameString();
					const wchar_t *name=(const wchar_t *)*FS;
					_wfopen_s(&fr,name,L"wb");
					if (fr)
						{
						if(fwrite(pdata,tlen,1,fr)!=1)
							{
							fclose(fr);
							_wunlink(name);
							}
						else fclose(fr);
						}
					free(pdata);
					}
				}
			}
		section++;
		}
	while(1);
	if (pextra2)
		{	
		free(pextra2);
		}
	}
	if (_pextra[csp].invisible)
		{
		G[csp]->SetActorHiddenInGame(true);
		}
	wchar_t mess[1024];
	swprintf(mess,TEXT("Vup object %u/%u loaded"), csp+1,_Nsp);
	UE_LOG(LogTemp, Display, mess);
	if(vupdll_settitle) vupdll_settitle(mess);
	}

return 0;
}
